package regex;

class Chars {
   public static final int EMPTY = 0;
   public static final int CHARACTER = 1;
   public static final int LINE_HEAD = 2;
   public static final int LINE_TAIL = 3;
   public static final int NONE = 4;
   private char begin;
   private char end;
   private int type;

   public char begin() {
      return this.begin;
   }

   public char end() {
      return this.end;
   }

   public void set(char var1, char var2) {
      this.begin = var1;
      this.end = var2;
   }

   public void setEnd(char var1) {
      this.end = var1;
   }

   public boolean hasChars(Chars var1) {
      if (this.type == 4) {
         return false;
      } else {
         return this.begin <= var1.begin() && var1.begin() <= this.end || this.begin <= var1.end() && var1.end() <= this.end;
      }
   }

   private Chars() {
   }

   public Chars(char var1) {
      this(var1, var1);
   }

   public Chars(char var1, char var2) {
      this.begin = var1;
      this.end = var2;
      this.type = 1;
   }

   public Chars(int var1) {
      this.type = var1;
   }

   public String toString() {
      String var1 = "";
      switch (this.type) {
         case 0:
            var1 = "EMPTY";
            break;
         case 1:
            if (this.begin == this.end) {
               var1 = "'" + this.escape(this.begin) + "'";
            } else {
               var1 = "'" + this.escape(this.begin) + "-" + this.escape(this.end) + "'";
            }
            break;
         case 2:
            var1 = "LHEAD";
            break;
         case 3:
            var1 = "LTAIL";
            break;
         case 4:
            var1 = "NONE";
      }

      return var1;
   }

   public int type() {
      return this.type;
   }

   public boolean equals(Object var1) {
      if (var1 != null && var1 instanceof Chars) {
         Chars var2 = (Chars)var1;
         if (this.type != 1) {
            return this.type == var2.type;
         } else {
            return this.begin == var2.begin && this.end == var2.end;
         }
      } else {
         return false;
      }
   }

   public void setType(int var1) {
      this.type = var1;
   }

   public boolean has(char var1) {
      if (this.type == 4) {
         return false;
      } else {
         return this.begin <= var1 && var1 <= this.end;
      }
   }

   public void setBegin(char var1) {
      this.begin = var1;
   }

   public boolean isEmpty() {
      return this.type == 0;
   }

   private String escape(char var1) {
      String var2;
      switch (var1) {
         case '\b':
            var2 = "\\b";
            break;
         case '\t':
            var2 = "\\t";
            break;
         case '\n':
            var2 = "\\n";
            break;
         case '\u000b':
         case '\f':
         default:
            var2 = (new Character(var1)).toString();
            break;
         case '\r':
            var2 = "\\r";
      }

      return var2;
   }
}
