package regex;

public class RegExpCore {
   protected String pattern;
   protected RegExpDFA dfa;

   public String toString() {
      return this.pattern;
   }

   public RegExpCore() {
   }

   public RegExpCore(String var1) throws RegExpSyntaxException, NFABuildException {
      this.setPattern(var1);
   }

   public String nfaString() {
      return RegExpDebug.nfaToString(this.dfa.getNfa());
   }

   public String treeString() {
      return RegExpDebug.treeToString(this.dfa.getTree());
   }

   public String dfaString() {
      return RegExpDebug.dfaToString(this.dfa);
   }

   public void setPattern(String var1) throws RegExpSyntaxException, NFABuildException {
      this.pattern = var1;
      RegExpParser var3 = new RegExpParser();
      RTree var2 = var3.parse(var1);
      RegExpNFA var4 = new RegExpNFA(var2);
      this.dfa = new RegExpDFA(var4);
   }

   public String pattern() {
      return this.pattern;
   }
}
